(in-package #:asdf-user)

(defsystem :scopes
  :author "cyberconcepts.org Team <team@cyberconcepts.org>"
  :license "MIT"
  :version "0.0.1"
  :homepage "https://www.cyberconcepts.org"
  :description "Generic data processing."
  :depends-on (:alexandria :chanl :cl-dotenv :com.inuoe.jzon :dbi 
               :local-time :log4cl :str :sxql)
  :components ((:file "config" :depends-on ("util"))
               (:file "core/core" 
                      :depends-on ("core/message" "config" 
                                   "forge/forge" "util"))
               (:file "core/message")
               (:file "forge/forge")
               (:file "storage/storage")
               (:file "storage/tracking" :depends-on ("storage/storage"))
               (:file "util")
               (:file "testing" :depends-on ("util"))
               (:file "test/test-config" :depends-on ("testing" "config"))
               (:file "test/test-core" :depends-on ("testing" "core/core"))
               (:file "test/test-forge" :depends-on ("testing" "forge/forge"))
               (:file "test/test-storage" 
                      :depends-on ("testing" 
                                   "storage/storage" "storage/tracking")))
  :long-description "scopes: generic data processing facilities."
  ;;#.(uiop:read-file-string
  ;;   (uiop:subpathname *load-pathname* "README.md")))
  :in-order-to ((test-op (test-op "scopes/test"))))

(defsystem :scopes/test
  :depends-on (:scopes)
  :components ((:file "test/test-config")
               (:file "test/test-core")
               (:file "test/test-forge")
               (:file "test/test-storage"))
  :perform (test-op (o c) 
    (symbol-call :scopes/test-config :run)
    (symbol-call :scopes/test-core :run)
    (symbol-call :scopes/test-forge :run)
    (symbol-call :scopes/test-storage :run-all)))
